(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/BehaviorSubject'), require('rxjs/add/operator/filter'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs/BehaviorSubject', 'rxjs/add/operator/filter', '@angular/common'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.nowzooAngularBootstrapLite = global.ng.nowzooAngularBootstrapLite || {}),global.ng.core,global.Rx,global.Rx,global.ng.common));
}(this, (function (exports,_angular_core,rxjs_BehaviorSubject,rxjs_add_operator_filter,_angular_common) { 'use strict';

var NzbModalStatus = {};
NzbModalStatus.uninitialized = 0;
NzbModalStatus.initialized = 1;
NzbModalStatus.showing = 2;
NzbModalStatus.shown = 3;
NzbModalStatus.hiding = 4;
NzbModalStatus.hidden = 5;
NzbModalStatus[NzbModalStatus.uninitialized] = "uninitialized";
NzbModalStatus[NzbModalStatus.initialized] = "initialized";
NzbModalStatus[NzbModalStatus.showing] = "showing";
NzbModalStatus[NzbModalStatus.shown] = "shown";
NzbModalStatus[NzbModalStatus.hiding] = "hiding";
NzbModalStatus[NzbModalStatus.hidden] = "hidden";
var NzbModalComponent = (function () {
    function NzbModalComponent() {
        this.initialized = new _angular_core.EventEmitter();
    }
    /**
     * @return {?}
     */
    NzbModalComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.initialized.next();
        });
    };
    return NzbModalComponent;
}());
NzbModalComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'nzb-modal',
                template: "\n\t\t<div #modalElement tabindex=\"-1\" role=\"dialog\">\n\t\t\t<div #dialogElement role=\"document\">\n\t\t\t\t<div class=\"modal-content\">\n\t\t\t\t\t<ng-content></ng-content>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>"
            },] },
];
/**
 * @nocollapse
 */
NzbModalComponent.ctorParameters = function () { return []; };
NzbModalComponent.propDecorators = {
    'modalElement': [{ type: _angular_core.ViewChild, args: ['modalElement',] },],
    'dialogElement': [{ type: _angular_core.ViewChild, args: ['dialogElement',] },],
    'initialized': [{ type: _angular_core.Output },],
};
var NzbModalOptions = (function () {
    function NzbModalOptions() {
        this.backdrop = true;
        this.keyboard = true;
        this.focus = true;
        this.animation = true;
        this.size = null;
    }
    return NzbModalOptions;
}());
NzbModalOptions.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
NzbModalOptions.ctorParameters = function () { return []; };
var NzbModalResult = (function () {
    function NzbModalResult() {
        this.dismissed = true;
        this.data = null;
    }
    return NzbModalResult;
}());
var NzbDynamicContent = (function () {
    /**
     * @param {?} nodes
     * @param {?=} viewRef
     * @param {?=} componentRef
     */
    function NzbDynamicContent(nodes, viewRef, componentRef) {
        this.nodes = nodes;
        this.viewRef = viewRef;
        this.componentRef = componentRef;
    }
    return NzbDynamicContent;
}());
var NzbDynamicContentComponent = (function () {
    function NzbDynamicContentComponent() {
    }
    return NzbDynamicContentComponent;
}());
NzbDynamicContentComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'nzb-dynamic-content',
                template: "<ng-content></ng-content>"
            },] },
];
/**
 * @nocollapse
 */
NzbDynamicContentComponent.ctorParameters = function () { return []; };
/**
 * NzbDynamicContentFactoryService class.
 */
var NzbDynamicContentService = (function () {
    /**
     * @param {?} injector
     * @param {?} appRef
     * @param {?} cfr
     * @param {?} rendererFactory
     */
    function NzbDynamicContentService(injector, appRef, cfr, rendererFactory) {
        this.injector = injector;
        this.appRef = appRef;
        this.cfr = cfr;
        this.rendererFactory = rendererFactory;
        this.renderer = rendererFactory.createRenderer(null, null);
    }
    /**
     * Creates a dynamic content entry.
     * @param {?} content
     * @param {?} templateContext
     * @param {?} contentComponenInjector
     * @param {?} allowHTML
     * @return {?}
     */
    NzbDynamicContentService.prototype.createDynamicContent = function (content, templateContext, contentComponenInjector, allowHTML) {
        if (!content) {
            return new NzbDynamicContent([]);
        }
        if (content instanceof _angular_core.TemplateRef) {
            var /** @type {?} */ viewRef = content.createEmbeddedView(templateContext);
            return new NzbDynamicContent([viewRef.rootNodes], viewRef);
        }
        if (typeof content === 'string') {
            var /** @type {?} */ el = void 0;
            if (allowHTML) {
                el = this.renderer.createElement('div');
                el.innerHTML = content;
            }
            else {
                el = this.renderer.createText(content);
            }
            return new NzbDynamicContent([[el]]);
        }
        try {
            var /** @type {?} */ componentFactory = this.cfr.resolveComponentFactory(content);
            var /** @type {?} */ componentRef = componentFactory.create(contentComponenInjector);
            return new NzbDynamicContent([[componentRef.location.nativeElement]], componentRef.hostView, componentRef);
        }
        catch (e) {
            return new NzbDynamicContent([]);
        }
    };
    /**
     * @param {?} dynamicContent
     * @return {?}
     */
    NzbDynamicContentService.prototype.attach = function (dynamicContent) {
        var /** @type {?} */ factory = this.cfr.resolveComponentFactory(NzbDynamicContentComponent);
        var /** @type {?} */ componentRef = factory.create(this.injector, dynamicContent.nodes);
        if (dynamicContent.viewRef) {
            this.appRef.attachView(dynamicContent.viewRef);
        }
        this.appRef.attachView(componentRef.hostView);
        this.renderer.appendChild(document.body, componentRef.location.nativeElement);
        return componentRef;
    };
    return NzbDynamicContentService;
}());
NzbDynamicContentService.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
NzbDynamicContentService.ctorParameters = function () { return [
    { type: _angular_core.Injector, },
    { type: _angular_core.ApplicationRef, },
    { type: _angular_core.ComponentFactoryResolver, },
    { type: _angular_core.RendererFactory2, },
]; };
/**
 * NzbService class.
 */
var NzbService = (function () {
    /**
     * @param {?} cfr
     * @param {?} injector
     * @param {?} appRef
     * @param {?} rendererFactory
     * @param {?} contentService
     * @param {?} defaultModalOptions
     */
    function NzbService(cfr, injector, appRef, rendererFactory, contentService, defaultModalOptions) {
        this.cfr = cfr;
        this.injector = injector;
        this.appRef = appRef;
        this.rendererFactory = rendererFactory;
        this.contentService = contentService;
        this.defaultModalOptions = defaultModalOptions;
        this.elementCounter = 0;
        this.renderer = this.rendererFactory.createRenderer(null, null);
        this.elementCounter = 0;
    }
    /**
     * @param {?} prefix
     * @return {?}
     */
    NzbService.prototype.getUniqueId = function (prefix) {
        prefix = prefix || 'nzb-generated-';
        this.elementCounter++;
        return prefix + this.elementCounter.toString();
    };
    /**
     * @return {?}
     */
    NzbService.prototype.createModal = function () {
        return new NzbModal(this);
    };
    return NzbService;
}());
NzbService.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
NzbService.ctorParameters = function () { return [
    { type: _angular_core.ComponentFactoryResolver, },
    { type: _angular_core.Injector, },
    { type: _angular_core.ApplicationRef, },
    { type: _angular_core.RendererFactory2, },
    { type: NzbDynamicContentService, },
    { type: NzbModalOptions, },
]; };
var NzbModal = (function () {
    /**
     * Don't use this constructor directly. Use NzbService.createModal instead.
     * @see 	NzbService
     * @param {?} nzbService
     */
    function NzbModal(nzbService) {
        this.nzbService = nzbService;
        this.ariaLabelledById = null;
        this.renderer = nzbService.renderer;
        this.defaultModalOptions = nzbService.defaultModalOptions;
        this.cfr = nzbService.cfr;
        this.injector = nzbService.injector;
        this.appRef = nzbService.appRef;
        this.contentService = nzbService.contentService;
        this.onShow = new _angular_core.EventEmitter();
        this.onShown = new _angular_core.EventEmitter();
        this.onHide = new _angular_core.EventEmitter();
        this.onHidden = new _angular_core.EventEmitter();
        this.status = new rxjs_BehaviorSubject.BehaviorSubject(NzbModalStatus.uninitialized);
        this.result = new rxjs_BehaviorSubject.BehaviorSubject(null);
    }
    /**
     * Shows the modal.
     * @param {?} content
     * @param {?=} options
     * @param {?=} ariaLabelledById
     * @return {?}
     */
    NzbModal.prototype.show = function (content, options, ariaLabelledById) {
        this._show(content, options, ariaLabelledById);
    };
    /**
     * Use this method to close the modal when the user "sucessfully" completes the modal.
     * The modal's `result.dismissed` will be false and `result.data` will be whatever you pass.
     * @param {?=} data
     * @return {?}
     */
    NzbModal.prototype.close = function (data) {
        var /** @type {?} */ result = new NzbModalResult();
        result.dismissed = false;
        result.data = data;
        this.result.next(result);
        this.hide();
    };
    /**
     * Use this method to indicate the user has "cancelled out" of the modal.
     * The modal's `result.dismissed` will be true and `result.data` will be null.
     * @return {?}
     */
    NzbModal.prototype.dismiss = function () {
        var /** @type {?} */ result = new NzbModalResult();
        result.dismissed = true;
        result.data = null;
        this.result.next(result);
        this.hide();
    };
    /**
     * A promise that resolves when the modal has been initialized but not yet shown.
     * @return {?}
     */
    NzbModal.prototype.initialized = function () {
        var _this = this;
        var /** @type {?} */ p = new Promise(function (resolve) {
            var /** @type {?} */ sub = _this.status
                .filter(function (val) { return val === NzbModalStatus.initialized; }).subscribe(function (val) {
                sub.unsubscribe();
                resolve();
            });
        });
        return p;
    };
    /**
     * A promise that resolves once when the modal is opened, i.e. after all the Bootstrap animations complete.
     * @return {?}
     */
    NzbModal.prototype.opened = function () {
        var _this = this;
        var /** @type {?} */ p = new Promise(function (resolve) {
            var /** @type {?} */ sub = _this.status
                .filter(function (val) { return val === NzbModalStatus.shown; }).subscribe(function (val) {
                sub.unsubscribe();
                resolve();
            });
        });
        return p;
    };
    /**
     * A promise that resolves once when the modal is hidden, i.e. after all the Bootstrap animations complete.
     * @return {?}
     */
    NzbModal.prototype.closed = function () {
        var _this = this;
        var /** @type {?} */ p = new Promise(function (resolve) {
            var /** @type {?} */ sub = _this.status
                .filter(function (val) { return val === NzbModalStatus.hidden; }).subscribe(function (val) {
                var /** @type {?} */ result = _this.result.value;
                if (!_this.result.value) {
                    _this.result.next(new NzbModalResult());
                }
                sub.unsubscribe();
                resolve(_this.result.value);
            });
        });
        return p;
    };
    /**
     * Use this method in ngOnDestroy to ensure the modal is hidden gracefully
     * when the component that created it is destroyed, e.g. on a route change.
     * @return {?}
     */
    NzbModal.prototype.destroy = function () {
        var /** @type {?} */ status = this.status.value;
        if (status === NzbModalStatus.shown || status === NzbModalStatus.showing || status === NzbModalStatus.initialized) {
            this.dismiss();
        }
        else {
            this.remove();
        }
    };
    /**
     * If you've opened the modal with a component type as content,
     * this will return the underlying ComponentRef.
     * @return {?}
     */
    NzbModal.prototype.getContentComponentRef = function () {
        if (this.dynamicContent && this.dynamicContent.componentRef) {
            return this.dynamicContent.componentRef;
        }
        return null;
    };
    /**
     * Get an observable of the modal status
     * @return {?}
     */
    NzbModal.prototype.getStatusObservable = function () {
        return this.status.asObservable();
    };
    /**
     * Get an observable of the modal result
     * @return {?}
     */
    NzbModal.prototype.getResultObservable = function () {
        return this.result.asObservable();
    };
    /**
     * @param {?} content
     * @param {?=} options
     * @param {?=} ariaLabelledById
     * @return {?}
     */
    NzbModal.prototype._show = function (content, options, ariaLabelledById) {
        var _this = this;
        var /** @type {?} */ factory = this.cfr.resolveComponentFactory(NzbModalComponent);
        this.ariaLabelledById = ariaLabelledById ? ariaLabelledById : null;
        this.result.next(null);
        this.options = this.initializeOptions(options);
        this.dynamicContent = this.getContent(content);
        this.modalComponentRef = factory.create(this.injector, this.dynamicContent.nodes);
        var /** @type {?} */ sub = this.modalComponentRef.instance.initialized.subscribe(function () {
            _this.onModalComponentInitialized();
            sub.unsubscribe();
        });
        this.appRef.attachView(this.modalComponentRef.hostView);
        if (this.dynamicContent.viewRef) {
            this.appRef.attachView(this.dynamicContent.viewRef);
        }
        this.renderer.appendChild(document.body, this.modalComponentRef.location.nativeElement);
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.onModalComponentInitialized = function () {
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ $el = jQuery(this.modalComponentRef.instance.modalElement.nativeElement);
        var /** @type {?} */ options = Object.assign({}, this.options, { show: true });
        this.setAriaHidden(true);
        this.setAriaLabelledBy();
        this.initializeClasses();
        this.initializeEvents();
        this.status.next(NzbModalStatus.initialized);
        setTimeout(function () {
            $el.modal(options);
        });
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.hide = function () {
        if (this.modalComponentRef) {
            var /** @type {?} */ $el = jQuery(this.modalComponentRef.instance.modalElement.nativeElement);
            $el.modal('hide');
        }
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.remove = function () {
        this.removeEvents();
        if (this.modalComponentRef && this.dynamicContent) {
            if (this.dynamicContent.viewRef) {
                this.appRef.detachView(this.dynamicContent.viewRef);
            }
            this.appRef.detachView(this.modalComponentRef.hostView);
            this.modalComponentRef.destroy();
            this.status.next(NzbModalStatus.uninitialized);
        }
        this.modalComponentRef = null;
        this.dynamicContent = null;
    };
    /**
     * @param {?=} content
     * @return {?}
     */
    NzbModal.prototype.getContent = function (content) {
        return this.contentService.createDynamicContent(content, { modal: this }, _angular_core.ReflectiveInjector.resolveAndCreate([{ provide: NzbModal, useValue: this }], this.injector), true);
    };
    /**
     * @param {?} raw
     * @return {?}
     */
    NzbModal.prototype.initializeOptions = function (raw) {
        var /** @type {?} */ injected = typeof this.defaultModalOptions === 'object' ? this.defaultModalOptions : {};
        var /** @type {?} */ options = new NzbModalOptions();
        raw = typeof raw === 'object' ? raw : {};
        if (typeof raw.backdrop === 'boolean' || 'static' === raw.backdrop) {
            options.backdrop = raw.backdrop;
        }
        else {
            if (typeof injected.backdrop === 'boolean' || 'static' === injected.backdrop) {
                options.backdrop = injected.backdrop;
            }
        }
        if (typeof raw.keyboard === 'boolean') {
            options.keyboard = raw.keyboard;
        }
        else {
            if (typeof injected.keyboard === 'boolean') {
                options.keyboard = injected.keyboard;
            }
        }
        if (typeof raw.focus === 'boolean') {
            options.focus = raw.focus;
        }
        else {
            if (typeof injected.focus === 'boolean') {
                options.focus = injected.focus;
            }
        }
        if (typeof raw.animation === 'boolean') {
            options.animation = raw.animation;
        }
        else {
            if (typeof injected.animation === 'boolean') {
                options.animation = injected.animation;
            }
        }
        if (['sm', 'lg'].indexOf(raw.size) > -1) {
            options.size = raw.size;
        }
        else {
            if (['sm', 'lg'].indexOf(injected.size) > -1) {
                options.size = injected.size;
            }
        }
        return options;
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.setAriaLabelledBy = function () {
        var /** @type {?} */ labelId;
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ el = this.modalComponentRef.instance.modalElement.nativeElement;
        var /** @type {?} */ $el = jQuery(el);
        if (typeof this.ariaLabelledById === 'string' && this.ariaLabelledById.trim().length > 0) {
            labelId = this.ariaLabelledById.trim();
        }
        else {
            labelId = this.nzbService.getUniqueId('nzb-modal-label-');
        }
        var /** @type {?} */ $label = jQuery('#' + labelId, $el);
        if ($label.length > 0) {
            this.renderer.setAttribute(el, 'aria-labelledby', labelId);
            return;
        }
        $label = jQuery('.modal-title', $el).first();
        if ($label.length > 0) {
            if ($label.attr('id') && $label.attr('id').length > 0) {
                labelId = $label.attr('id');
            }
            else {
                this.renderer.setAttribute($label.get(0), 'aria-labelledby', labelId);
            }
            this.renderer.setAttribute(el, 'aria-labelledby', labelId);
        }
    };
    /**
     * @param {?} hidden
     * @return {?}
     */
    NzbModal.prototype.setAriaHidden = function (hidden) {
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ el = this.modalComponentRef.instance.modalElement.nativeElement;
        this.renderer.setAttribute(el, 'aria-hidden', hidden ? 'true' : 'false');
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.initializeClasses = function () {
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ modalEl = this.modalComponentRef.instance.modalElement.nativeElement;
        var /** @type {?} */ dialogEl = this.modalComponentRef.instance.dialogElement.nativeElement;
        this.renderer.addClass(modalEl, 'modal');
        if (this.options.animation) {
            this.renderer.addClass(modalEl, 'fade');
        }
        this.renderer.addClass(dialogEl, 'modal-dialog');
        if (this.options.size) {
            this.renderer.addClass(dialogEl, 'modal-' + this.options.size);
        }
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.initializeEvents = function () {
        var _this = this;
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ $el = jQuery(this.modalComponentRef.instance.modalElement.nativeElement);
        $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', function (event) {
            switch (event.type) {
                case 'show':
                    _this.setAriaHidden(false);
                    _this.status.next(NzbModalStatus.showing);
                    _this.onShow.emit(event);
                    break;
                case 'shown':
                    _this.status.next(NzbModalStatus.shown);
                    _this.onShown.emit(event);
                    break;
                case 'hide':
                    _this.status.next(NzbModalStatus.hiding);
                    _this.onHide.emit(event);
                    break;
                case 'hidden':
                    _this.setAriaHidden(true);
                    _this.status.next(NzbModalStatus.hidden);
                    _this.onHidden.emit(event);
                    _this.remove();
                    break;
            }
        });
    };
    /**
     * @return {?}
     */
    NzbModal.prototype.removeEvents = function () {
        if (!this.modalComponentRef) {
            return;
        }
        var /** @type {?} */ $el = jQuery(this.modalComponentRef.instance.modalElement.nativeElement);
        $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
    };
    return NzbModal;
}());
NzbModal.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
NzbModal.ctorParameters = function () { return [
    { type: NzbService, },
]; };
var NzbTooltipOptions = (function () {
    function NzbTooltipOptions() {
        this.animation = true;
        this.container = 'body';
        this.delay = 0;
        this.html = false;
        this.placement = 'top';
        this.template = '<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>';
        this.title = null;
        this.trigger = 'hover focus';
        this.constraints = [];
        this.offset = '0 0';
    }
    return NzbTooltipOptions;
}());
NzbTooltipOptions.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
NzbTooltipOptions.ctorParameters = function () { return []; };
var NzbTooltipDirective = (function () {
    /**
     * @param {?} element
     */
    function NzbTooltipDirective(element) {
        this.element = element;
    }
    /**
     * @return {?}
     */
    NzbTooltipDirective.prototype.ngAfterViewInit = function () {
        jQuery(this.element.nativeElement).tooltip();
    };
    /**
     * @return {?}
     */
    NzbTooltipDirective.prototype.ngOnDestroy = function () {
        jQuery(this.element.nativeElement).tooltip('dispose');
    };
    return NzbTooltipDirective;
}());
NzbTooltipDirective.decorators = [
    { type: _angular_core.Directive, args: [{
                selector: '[data-toggle="tooltip"]'
            },] },
];
/**
 * @nocollapse
 */
NzbTooltipDirective.ctorParameters = function () { return [
    { type: _angular_core.ElementRef, },
]; };
var NzbModule = (function () {
    function NzbModule() {
    }
    return NzbModule;
}());
NzbModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [
                    _angular_common.CommonModule
                ],
                declarations: [
                    NzbDynamicContentComponent,
                    NzbModalComponent,
                    NzbTooltipDirective
                ],
                exports: [
                    NzbDynamicContentComponent,
                    NzbModalComponent,
                    NzbTooltipDirective
                ],
                entryComponents: [
                    NzbDynamicContentComponent,
                    NzbModalComponent
                ],
                providers: [
                    NzbService,
                    NzbDynamicContentService,
                    NzbModalOptions,
                    NzbTooltipOptions
                ]
            },] },
];
/**
 * @nocollapse
 */
NzbModule.ctorParameters = function () { return []; };

exports.NzbModalStatus = NzbModalStatus;
exports.NzbModal = NzbModal;
exports.NzbModalOptions = NzbModalOptions;
exports.NzbModalResult = NzbModalResult;
exports.NzbModalComponent = NzbModalComponent;
exports.NzbTooltipOptions = NzbTooltipOptions;
exports.NzbTooltipDirective = NzbTooltipDirective;
exports.NzbDynamicContent = NzbDynamicContent;
exports.NzbDynamicContentService = NzbDynamicContentService;
exports.NzbDynamicContentComponent = NzbDynamicContentComponent;
exports.NzbService = NzbService;
exports.NzbModule = NzbModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nowzoo-angular-bootstrap-lite.umd.js.map
