import { ComponentFactoryResolver, ReflectiveInjector, RendererFactory2, ComponentRef, Injector, ApplicationRef } from '@angular/core';
import { NzbDynamicContent } from './nzb-dynamic-content';
import { NzbDynamicContentComponent } from './nzb-dynamic-content.component';
/**
 * NzbDynamicContentFactoryService class.
 */
export declare class NzbDynamicContentService {
    private injector;
    private appRef;
    private cfr;
    private rendererFactory;
    private renderer;
    constructor(injector: Injector, appRef: ApplicationRef, cfr: ComponentFactoryResolver, rendererFactory: RendererFactory2);
    /**
     * Creates a dynamic content entry.
     * @param  {any}                content                 A string, component type or TemplateRef
     * @param  {any}                templateContext         The context to be attached to the template view, e.g. the modal or tooltip instance.
     * @param  {ReflectiveInjector} contentComponenInjector The injector to be used for creating the content component. This injects the modal/tooltip/popover instance into the component.
     * @param  {boolean}            allowHTML               Only used if content is a string. If false, we create a text node,otherwice we create elements.
     * @return {NzbDynamicContent}
     */
    createDynamicContent(content: any, templateContext: any, contentComponenInjector: ReflectiveInjector, allowHTML: boolean): NzbDynamicContent;
    attach(dynamicContent: NzbDynamicContent): ComponentRef<NzbDynamicContentComponent>;
}
